import java.io.*;
import java.util.*;

/*
Si consideri la definizione di coppia in Pair.Java, per coppie non modificabili.
Si chiede di:
 (a) Ridefinirla in un un ADT, MUPairADT.java, per coppie modificabili a componenti non nulli ed equipaggiata degli additionals (equals,clone,toString,elements) necessari;
 (b) Fornire AF e I  di (della rappresentazione data in) MUPairADT.java;
 (c) Fornire un caso di uso di MUPairADT.java;
 (d) Provare la correttezza di I.

 public class Pair <A,B> {
   public final A left;
   public final B right;
   public Pair (A x, B y) {
      left = x;
      right = y;
   }
}
 */

/* (a) */
class invalidArgException extends Exception{
}

class MuPairADTe <A,B> implements Cloneable{
    private A left;//da nascondere
    private B right;//da nascondere
    public MuPairADTe(A x, B y) throws invalidArgException{
        if(x==null||y==null) throw new invalidArgException();
        left = x;
        right = y;
    }
    public A getLeft(){//da aggiungere per uso effettivo
        return left;
    }
    public B getRight(){//da aggiungere per uso effettivo
        return right;
    }
    public void setLeft(A x)throws invalidArgException{
                        //da aggiungere per uso effettivo
        if(x==null) throw new invalidArgException();
        left = x;
    }
    public void setRight(B y)throws invalidArgException{
                        //da aggiungere per uso effettivo
        if(y==null) throw new invalidArgException();
        right = y;
    }
// Metodi additional
//Equals ereditata perchè classe di valori mutable
    public MuPairADTe<A,B> clone() throws CloneNotSupportedException{
        return (new MuPairADTe<A,B>(left.clone(),right.clone()));
    }
    public String toString(){
        return ("("+left.toString()+","+right.toString()+")");
    }

}

/* (b) 
Sia [ImPairADT<Ta,Tb>]={(x,y) | x\inTa, y\inTb, Ta\in[A], Tb\in[B]}, l'insieme dei valori
astratti definiti da ImPairADT<Ta,Tb>. Allora, per ogni valore concreto c esprimibile con
lo stato concreto definito dai fields della classe:
AF(c) = (c.left,c.right)
I(c) = c.left!=null & c.right!=null
*/

/* (c) */
class main{
    public static void main(String args[]) throws invalidArgException{
        MuPairADTe <String,Integer> myAddress = new MuPairADTe<String,Integer>("Pontecorvo",4);
        System.out.println("l'indirizzo è via " + myAddress.getLeft() + ", " + myAddress.getRight());
        myAddress.setRight(12);
        System.out.println("l'indirizzo è cambiato in " + myAddress.getLeft() + ", " + myAddress.getRight());        
    }
}

/* (d)
 Dobbiamo provare che I(c)= c.left!=null & c.right!=null è sempre verificato dallo stato 
 di un valore astratto di tipo MuPairADT.
 Fatto1: Costruttori. Il primo stm controlla che il valore (x,y) è costruito solo se x!=null!=y.
 Fatto2: Modificatori. Dal primo stm di setLeft (risp. setRight) vediamo che lo stato è modificato solo se l'argomento è diverso da null. Allora assumendo come ipotesi induttiva l'invariante vero sullo stato prima dell'invocazione, concludiamo che l'invariante è vero dopo un qualunque numero di invocazioni dei modificatori.
 Conclusione. Da Fatto1 e Fatto2 segue che I(c) è sempre soddisfatto.
 */
