import java.lang.*;
import java.io.*;
import java.util.*;

/* AltriEsercizi8 - Esercizio2 del 16/5/2016
 Si definisca in Java una tipo astratto per relazioni binarie, su tipi generici, 
 come quelle in esercizio1 ma per valori MODIFICABILI e con le sole operazioni 
 addPair, removePair, isIn. In particolare, si fornisca:\\
 (a) Interfaccia API;\\
 (b) Intestazione della classe;\\
 (c) Stato Concreto;\\
 (e) AF, I;\\
 (f) Definizione dei metodi addPair, removePair, isIn;\\
 (g) Trattamento degli Additionals (clone, equals, toString, elements);\\
 (h) Una versione adatta dei casi d'uso discussi in esercizio1.
*/

interface MuCloneable extends Cloneable{
    public Object clone()throws CloneNotSupportedException;
}

/* (a,b,c) */
class MuRelazioneADTX<A,B> implements MuCloneable, MuRelazioneAPIX<A,B>{//punto (b)
    private Vector<ImPairADTX<A,B>> rep;//punto (c)
    // punto (d)
    // Let {(x,y)| x\in['a], y\in['b]}\in[MuRelazione <A,B>] be a (finite) relation.
    // Then:
    // AF(c) = {(x,y) | (x,y)=c.get(i) (for i\in[0..c.size()-1])}
    // I(c) = (for i,j\in[0..c.size()-1]) if (i!=j) then !(c.get(i).equals(c.get(j).

/* punto (e) */
    public MuRelazioneADTX(){
        rep = new Vector<ImPairADTX<A,B>>();
    }
    public void addPair (A x, B y) throws invalidArgException
    {//perchè non usare solo rep.add(p)?
        ImPairADTX<A,B> p = new ImPairADTX<A,B>(x,y);
        for(ImPairADTX<A,B> u: rep){
            if (u.equals(p)) return;
        }
        rep.add(p);
    }
    public void removePair (A x, B y)throws invalidArgException
    {//perchè non usare solo rep.remove(p)?
        ImPairADTX<A,B> p = new ImPairADTX<A,B>(x,y);
        for(ImPairADTX<A,B> u: rep){
            if (u.equals(p)) {
                rep.remove(u);
                return;
            }
        }
    }
    public boolean isIn(A x, B y)throws invalidArgException
    {//perchè non usare solo rep.contains(p)?
        ImPairADTX<A,B> p = new ImPairADTX<A,B>(x,y);
        for(ImPairADTX<A,B> u: rep){
            if (u.equals(p)) return true;
        }
        return false;
    }
//ADDITIONALS -- punto (f)
    //public boolean equals(Object o)//ereditata
    public MuRelazioneADTX<A,B> clone() throws CloneNotSupportedException{
        MuRelazioneADTX<A,B> res = new MuRelazioneADTX<A,B>();
        res.rep = (Vector<ImPairADTX<A,B>>) rep.clone();
        return res;
    }
    public LinkedList<ImPairADTX<A,B>> elements(){
        LinkedList<ImPairADTX<A,B>> res = new LinkedList<ImPairADTX<A,B>>();
        for(ImPairADTX<A,B> u: rep){res.add(u);}
        return res;
    }
    public String toString(){
        String res = "{";
        if (isEmpty()) return res+"}";
        res = res + (rep.get(0)).toString();
        for (int i=1;i<rep.size();i++) res = res + ";" + (rep.get(i)).toString();
        return (res+"}");
    }
//AUXILIARIES
    private boolean isEmpty(){
        return (rep.size()==0);
    }
}

/* punto (g) -- vedi MainMuRelazioneADT.java

class main{
    public static <A> boolean simm(MuRelazioneADTX<A,A> r){//
        //notare l'introduzione della generica <A> locale alla definizione
        // del metodo. In alternativa, l'introduzione doveva essere fatta
        // nell'intestazione della classe.
        LinkedList<ImPairADTX<A,A>> elem = r.elements();
        for(ImPairADTX<A,A> u: elem){
            try{if (!r.isIn(u.getRight(),u.getLeft())) return false;}
            catch(invalidArgException e){}
        }
        return true;
    }
    public static <A,B> boolean incl(MuRelazioneADTX<A,B> r, MuRelazioneADTX<A,B> s){//
        //notare l'introduzione delle generiche <A,B> locali alla definizione
        // del metodo. In alternativa, l'introduzione doveva essere fatta
        // nell'intestazione della classe.
        LinkedList<ImPairADTX<A,B>> elem = r.elements();
        for(ImPairADTX<A,B> u: elem){
            try{if (!s.isIn(u.getLeft(),u.getRight())) return false;}
            catch(invalidArgException e){}
        }
        return true;
    }
    public static void main(String args[]) throws invalidArgException,CloneNotSupportedException {
        MuRelazioneADTX<Integer,Integer> shortest = new MuRelazioneADTX<Integer,Integer>();
        shortest.addPair(3,-5);
        System.out.println("E' shortest simmetrica? -- " + (main.simm(shortest)?"SI":"NO"));
        shortest.addPair(-5,3);
        System.out.println("E' shortest simmetrica? -- " + (main.simm(shortest)?"SI":"NO"));
        MuRelazioneADTX<Integer,Integer> shortest1 = new MuRelazioneADTX<Integer,Integer>();
        shortest1.addPair(-5,3);
        System.out.println("E' shortest1 inclusa in shortest? -- " + (incl(shortest1,shortest)?"SI":"NO"));
        System.out.println("E' shortest inclusa in shortest1? -- " + (incl(shortest,shortest1)?"SI":"NO"));
        
    }
}
*/
