
(* AltriEsercizi8 - Esercizio1 del 16/5/2016 
Si consideri lo ADT Relazione nel file Relazione.ml (distribuito mercoedì 11/5/2016). 
Si completi la definizione data con:\\
(a) AF, I\\
(b) Additionals\\
(c) Un caso di uso per verificare se un ('a,'b)relazione sia una relazione simmetrica.\\
(d) Un caso di uso per verificare se una relazione \`e contenuta in un'altra data.
*)

open List;;
exception Undefined;;

module type RELAZIONE =
 sig type ('a,'b) relazione 
  val relazioneC: unit -> ('a,'b) relazione 
  val addPair: ('a,'b) relazione -> 'a -> 'b -> ('a,'b) relazione 
  val removePair: ('a,'b) relazione -> 'a -> 'b -> ('a,'b) relazione
  val isIn: ('a,'b) relazione -> 'a -> 'b -> bool
  val getUno: ('a,'b) relazione -> 'b -> 'a list
  val getDue: ('a,'b) relazione -> 'a -> 'b list
(* additional *)
  val elements: ('a,'b) relazione -> ('a * 'b) list
  val toString: ('a,'b) relazione -> ('a -> string) -> ('b -> string) -> string
end;;
 
(* complerare con AF, I, additionals e caso di uso *)
module Relazione =
 (struct
  type ('a,'b) relazione = ('a * 'b) list  
(* (a)  Stato Concreto = ('a * 'b) list. Hence c is a value of type ('a * 'b) list.
  Let {(x,y)| x\in['a], y\in['b]}\in('a,'b) relazione] be a (finite) relation. Then:
     AF(c) = {(x,y) | (x,y)=hd(tl^i(c)) (for i\in[0..length(c)-1])}
     I(c) = true
*) 
  let relazioneC = fun () -> []
  let addPair r x y = (x,y)::r 
  let removePair r x y = 
     let g = fun u -> if u!=(x,y) then [u] else []
     in fold_right(append)(map g r)[]
  let isIn r x y = fold_right (||) (map ((=)(x,y)) r) false 
  let isDue(r,y) = fold_right (||) (map(fun u -> snd(u)=y) r) false (* inutile, perchè... *)
  let getUno r y = let g = fun u ->if(snd(u)=y)then[fst(u)]else[]
                     in fold_right(append)(map g r) []
  let getDue r x = let g = fun u ->if(fst(u)=x)then[snd(u)]else[]
                     in fold_right (append) (map g r) []
(* (b) *)
  let elements r = 
  		let rec remove x list = match list with [] -> [] 
  				| (y::ys) when (x=y) -> remove x ys
  				| y::ys -> y::(remove x ys)
  		in let rec single list = match list with
  				x::xs -> x::(single (remove x xs))
  				|[] -> []
  			in single r    		
 (* a wrong definition:
  let elements r = 
  		let rec single list = match list with
  				x::xs -> x::(single (removePair xs (fst x) (snd x)))
  				|[] -> []
  			in single r  
  WHY? *) 
   		
  let toString r aToString bToString = 
  		let pairString (x,y) = "("^(aToString x) ^ "," ^ (bToString y) ^ ")" in
  		let myList = elements r in
  		let myprefix = match myList with u::l -> "{"^(pairString u) |_ -> "{" in
  		let myfun = fun x l -> ("," ^ pairString x) ^ l in
  		myprefix ^ (fold_right (myfun) (tl myList) "") ^ "}"

end:RELAZIONE);;


(* (c) relazione simmetrica *)

open Relazione;;
let simm r = let elem =(elements r) and g = fun (x,y) -> isIn r y x
 	         in fold_right (&&) (map g elem) true;;
 	  
let shortest = relazioneC();;
let shortest1 = addPair shortest 3 (-5);;
"E' shortest1 simmetrica? -- " ^ if simm shortest1 then "SI" else "NO";;
let shortest2 = addPair shortest1 (-5) 3;;
"E' shortest2 simmetrica? -- " ^ if simm shortest2 then "SI" else "NO";;

(* (d) relazione contenuta *)

let incl r s = let relem = (elements r) and g = fun (x,y) -> isIn s x y
			   in fold_right (&&) (map g relem) true;;
"E' shortest2 inclusa in shortest1? -- " ^ if incl shortest2 shortest1 then "SI" else "NO";;
"E' shortest1 inclusa in shortest2? -- " ^ if incl shortest1 shortest2 then "SI" else "NO";;
