
(* AltriEsercizi8 - Esercizio3 del 16/5/2016 
Si assuma di operare su un sistema OCaml contenente il tipo astratto ('a,'b)relazione, 
definito come in esercizio1. Si chiede di specializzare la relazione binaria per operare 
con relazioni simmetriche. In particolare si deve fornire un nuovo tipo astratto specifico 
per relazioni simmetriche ed equipaggiato delle operazioni in ('a,'b)relazione, ovvero:\\
(a) Intestazione del modulo API\\
(b) Intestazione del modulo ADT\\
(c) Stato Concreto\\
(d) AF, I\\
(e) Definizione delle operazioni\\
(f) Additionals\\
(g) Si dica se sia possibile usare i casi di uso di esercizio1 per i nuovi valori 
    introdotti. 
*)

open List;;
#use "Relazione.ml";;
exception Undefined;;

(* (a) Il modulo API è una specializzazione di ('a,'b)relazione *)
module type RELAZIONES =
 sig type 'a relazioneS 
  val relazioneC: unit -> 'a relazioneS 
  val addPair: 'a relazioneS -> 'a -> 'a -> 'a relazioneS 
  val removePair: 'a relazioneS -> 'a -> 'a -> 'a relazioneS
  val isIn: 'a relazioneS -> 'a -> 'a -> bool
  val getUno: 'a relazioneS -> 'a -> 'a list
  val getDue: 'a relazioneS -> 'a -> 'a list
(* additional *)
  val elements: 'a relazioneS -> ('a * 'a) list
  val toString: 'a relazioneS -> ('a -> string) -> string
end;;
 
(* (b,c,d,e) *)
module RelazioneS =
 (struct
  type 'a relazioneS = ('a,'a) relazione  
(* (c) Stato Concreto = ('a,'a) relazione. Hence c is a value of type ('a,'a) relazione.
   (d) Let {(x,y)| x,y\in['a]}\in['a relazione] be a (finite) relation. Then:
       AF(c) = {(x,y),(y,x) | (x,y)\in c}
       I(c) = true
*)
(* (e) *) 
  let relazioneC = Relazione.relazioneC
  let addPair r x y =
  	let check = (Relazione.isIn r x y)||(Relazione.isIn r y x)
  	in if check then r else Relazione.addPair r x y 
  let removePair r x y = 
  		let r1 = Relazione.removePair r x y
  		in Relazione.removePair r1 y x
  let isIn r x y = (Relazione.isIn r x y)||(Relazione.isIn r y x)
  let getUno r y = (Relazione.getUno r y)@(Relazione.getDue r y)
  let getDue r x = getUno r x
(* (f) *)
  let elements r = 
  		let elem = Relazione.elements r and g = fun (x,y) l -> (y,x)::l
  		in fold_right g elem elem
  let toString r aToString = 
  		let pairString(x,y) = "(" ^ (aToString x) ^ "," ^ (aToString y) ^ ")" in
  		let myList = elements r in
  		let myprefix = match myList with u::l -> "{" ^ (pairString u) |_ -> "{" in
  		let myfun = fun x l -> (";" ^ pairString x) ^ l in
  		myprefix ^ (fold_right (myfun) (tl myList) "") ^ "}"
end:RELAZIONES);;

(* (g) casi di uso:
 NO. 
 simm introdotta in file Relazione.ml ha tipo:
 		val simm : ('a, 'a) Relazione.relazione -> bool = <fun>
 in particolare, usa relazioni di tipo ('a, 'a) Relazione.relazione
 ma noi qui operiamo con relazioni di tipo 'a relazioneS.RelazioneS
 incl in file Relazione.ml ha tipo: 
 	val incl: ('a, 'b) Relazione.relazione -> ('a, 'b) Relazione.relazione -> bool = <fun>
 ma noi qui operiamo con relazioni di tipo 'a relazioneS.RelazioneS
*)

